## srslte 18.06.1+ds.1

=== lib/CMakeLists.txt ===
#
# Copyright 2013-2017 Software Radio Systems Limited
#
# This file is part of srsLTE
#
# srsLTE is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# srsLTE is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# A copy of the GNU Affero General Public License can be found in
# the LICENSE file in the top-level directory of this distribution
# and at http://www.gnu.org/licenses/.
#

########################################################################
# Add subdirectories
########################################################################
add_subdirectory(src)
add_subdirectory(include)
add_subdirectory(examples)
add_subdirectory(test)

########################################################################
# Install library headers
########################################################################
INSTALL(  DIRECTORY include/
          DESTINATION "${INCLUDE_DIR}"
          FILES_MATCHING PATTERN "*.h" )

=== srsenb/src/CMakeLists.txt ===

add_subdirectory(phy)
add_subdirectory(mac)
add_subdirectory(upper)


# Link libstdc++ and libgcc
if(BUILD_STATIC)
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static-libstdc++ -static-libgcc")
endif(BUILD_STATIC)


if (RPATH)
  SET(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
endif (RPATH)


add_executable(srsenb main.cc enb.cc parser.cc enb_cfg_parser.cc metrics_stdout.cc)
target_link_libraries(srsenb  srsenb_upper
                              srsenb_mac
                              srsenb_phy
                              srslte_common
                              srslte_phy
                              srslte_upper
                              srslte_radio
                              ${CMAKE_THREAD_LIBS_INIT} 
                              ${Boost_LIBRARIES} 
                              ${SEC_LIBRARIES}
                              ${LIBCONFIGPP_LIBRARIES}
                              ${SCTP_LIBRARIES})

if (RPATH)
  set_target_properties(srsenb PROPERTIES INSTALL_RPATH ".")
endif (RPATH)

install(TARGETS srsenb DESTINATION ${RUNTIME_DIR})

########################################################################
# Option to run command after build (useful for remote builds)
########################################################################
if (NOT ${BUILDENB_CMD} STREQUAL "")
  message(STATUS "Added custom post-build-ENB command: ${BUILDENB_CMD}")
  add_custom_command(TARGET srsenb POST_BUILD COMMAND ${BUILDENB_CMD})
else(NOT ${BUILDENB_CMD} STREQUAL "")
  message(STATUS "No post-build-ENB command defined")
endif (NOT ${BUILDENB_CMD} STREQUAL "")

install(TARGETS srsenb DESTINATION ${RUNTIME_DIR})

=== srsepc/src/CMakeLists.txt ===
#
# Copyright 2013-2017 Software Radio Systems Limited
#
# This file is part of srsLTE
#
# srsLTE is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# srsLTE is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# A copy of the GNU Affero General Public License can be found in
# the LICENSE file in the top-level directory of this distribution
# and at http://www.gnu.org/licenses/.
#

add_subdirectory(mme)
add_subdirectory(hss)
add_subdirectory(spgw)
add_subdirectory(mbms-gw)

# Link libstdc++ and libgcc
if(BUILD_STATIC)
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static-libstdc++ -static-libgcc")
endif(BUILD_STATIC)


if (RPATH)
  SET(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
endif (RPATH)


add_executable(srsepc main.cc )
target_link_libraries(srsepc  srsepc_mme
                              srsepc_hss
                              srsepc_sgw
                              srslte_upper
                              srslte_common
                              ${CMAKE_THREAD_LIBS_INIT} 
                              ${Boost_LIBRARIES} 
                              ${SEC_LIBRARIES}
                              ${LIBCONFIGPP_LIBRARIES}
                              ${SCTP_LIBRARIES})

add_executable(srsmbms mbms-gw/main.cc )
target_link_libraries(srsmbms   srsepc_mbms_gw
                                srslte_upper
                                srslte_common
                                ${CMAKE_THREAD_LIBS_INIT} 
                                ${Boost_LIBRARIES} 
                                ${SEC_LIBRARIES}
                                ${LIBCONFIGPP_LIBRARIES}
                                ${SCTP_LIBRARIES})
if (RPATH)
  set_target_properties(srsepc PROPERTIES INSTALL_RPATH ".")
  set_target_properties(srsmbms PROPERTIES INSTALL_RPATH ".")
endif (RPATH)

install(TARGETS srsepc DESTINATION ${RUNTIME_DIR})
install(TARGETS srsmbms DESTINATION ${RUNTIME_DIR})

########################################################################
# Option to run command after build (useful for remote builds)
########################################################################
if (NOT ${BUILDEPC_CMD} STREQUAL "")
  message(STATUS "Added custom post-build-EPC command: ${BUILDENB_CMD}")
  add_custom_command(TARGET srsenb POST_BUILD COMMAND ${BUILDENB_CMD})
else(NOT ${BUILDEPC_CMD} STREQUAL "")
  message(STATUS "No post-build-EPC command defined")
endif (NOT ${BUILDEPC_CMD} STREQUAL "")

install(TARGETS srsepc DESTINATION ${RUNTIME_DIR})

=== srsue/test/CMakeLists.txt ===
#
# Copyright 2013-2017 Software Radio Systems Limited
#
# This file is part of srsLTE
#
# srsLTE is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# srsLTE is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# A copy of the GNU Affero General Public License can be found in
# the LICENSE file in the top-level directory of this distribution
# and at http://www.gnu.org/licenses/.
#

add_subdirectory(phy)
add_subdirectory(mac)
add_subdirectory(upper)

add_executable(metrics_test metrics_test.cc ../src/metrics_stdout.cc ../src/metrics_csv.cc)
target_link_libraries(metrics_test srslte_phy srslte_common)
add_test(metrics_test metrics_test -o ${CMAKE_CURRENT_BINARY_DIR}/ue_metrics.csv)

=== lib/src/phy/CMakeLists.txt ===
#
# Copyright 2013-2017 Software Radio Systems Limited
#
# This file is part of srsLTE
#
# srsLTE is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# srsLTE is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# A copy of the GNU Affero General Public License can be found in
# the LICENSE file in the top-level directory of this distribution
# and at http://www.gnu.org/licenses/.
#

add_subdirectory(agc)
add_subdirectory(ch_estimation)
add_subdirectory(common)
add_subdirectory(fec)
add_subdirectory(mimo)
add_subdirectory(phch)
add_subdirectory(rf)
add_subdirectory(sync)
add_subdirectory(utils)
add_subdirectory(channel)
add_subdirectory(dft)
add_subdirectory(io)
add_subdirectory(modem)
add_subdirectory(resampling)
add_subdirectory(scrambling)
add_subdirectory(ue)
add_subdirectory(enb)

set(srslte_srcs     $<TARGET_OBJECTS:srslte_agc>
                    $<TARGET_OBJECTS:srslte_ch_estimation>
                    $<TARGET_OBJECTS:srslte_phy_common>
                    $<TARGET_OBJECTS:srslte_fec>
                    $<TARGET_OBJECTS:srslte_mimo>
                    $<TARGET_OBJECTS:srslte_phch>
                    $<TARGET_OBJECTS:srslte_sync>
                    $<TARGET_OBJECTS:srslte_utils>
                    $<TARGET_OBJECTS:srslte_channel>
                    $<TARGET_OBJECTS:srslte_dft>
                    $<TARGET_OBJECTS:srslte_io>
                    $<TARGET_OBJECTS:srslte_modem>
                    $<TARGET_OBJECTS:srslte_resampling>
                    $<TARGET_OBJECTS:srslte_scrambling>
                    $<TARGET_OBJECTS:srslte_ue>
                    $<TARGET_OBJECTS:srslte_enb>
)

add_library(srslte_phy STATIC ${srslte_srcs})
target_link_libraries(srslte_phy ${FFT_LIBRARIES})

target_link_libraries(srslte_phy pthread m)
install(TARGETS srslte_phy DESTINATION ${LIBRARY_DIR})

=== lib/test/asn1/CMakeLists.txt ===
#
# Copyright 2013-2017 Software Radio Systems Limited
#
# This file is part of srsLTE
#
# srsLTE is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# srsLTE is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# A copy of the GNU Affero General Public License can be found in
# the LICENSE file in the top-level directory of this distribution
# and at http://www.gnu.org/licenses/.
#

add_executable(srslte_asn1_rrc_mcch_test srslte_asn1_rrc_mcch_test.cc)
target_link_libraries(srslte_asn1_rrc_mcch_test srslte_asn1 srslte_common)
add_test(srslte_asn1_rrc_mcch_test srslte_asn1_rrc_mcch_test)

add_executable(srslte_asn1_rrc_meas_test srslte_asn1_rrc_meas_test.cc)
target_link_libraries(srslte_asn1_rrc_meas_test srslte_common srslte_phy srslte_asn1)
add_test(srslte_asn1_rrc_meas_test srslte_asn1_rrc_meas_test)

=== lib/test/phy/CMakeLists.txt ===
#
# Copyright 2013-2017 Software Radio Systems Limited
#
# This file is part of srsLTE
#
# srsLTE is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# srsLTE is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# A copy of the GNU Affero General Public License can be found in
# the LICENSE file in the top-level directory of this distribution
# and at http://www.gnu.org/licenses/.
#

#######################################################################
# PHY TESTS
#######################################################################
add_executable(phy_dl_test phy_dl_test.c)
target_link_libraries(phy_dl_test srslte_phy srslte_common srslte_phy ${SEC_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
add_test(phy_dl_test phy_dl_test)

=== srsenb/test/upper/CMakeLists.txt ===
# IP tx/rx program test
add_executable(ip_test_enb ip_test.cc)
target_link_libraries(ip_test_enb srsenb_upper
                                  srsenb_mac
                                  srsenb_phy
                                  srslte_common
                                  srslte_phy
                                  srslte_upper
                                  srslte_radio
                                  ${CMAKE_THREAD_LIBS_INIT} 
                                  ${Boost_LIBRARIES} 
                                  ${SEC_LIBRARIES})

# Simple PLMN -> MCC/MNC test
add_executable(plmn_test plmn_test.cc)
target_link_libraries(plmn_test srsenb_upper srslte_asn1 )

=== srsepc/src/mbms-gw/CMakeLists.txt ===
#
# Copyright 2013-2017 Software Radio Systems Limited
#
# This file is part of srsLTE
#
# srsLTE is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# srsLTE is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# A copy of the GNU Affero General Public License can be found in
# the LICENSE file in the top-level directory of this distribution
# and at http://www.gnu.org/licenses/.
#

file(GLOB SOURCES "*.cc")
add_library(srsepc_mbms_gw STATIC ${SOURCES})
install(TARGETS srsepc_mbms_gw DESTINATION ${LIBRARY_DIR})

=== srsepc/src/spgw/CMakeLists.txt ===
#
# Copyright 2013-2017 Software Radio Systems Limited
#
# This file is part of srsLTE
#
# srsLTE is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# srsLTE is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# A copy of the GNU Affero General Public License can be found in
# the LICENSE file in the top-level directory of this distribution
# and at http://www.gnu.org/licenses/.
#

file(GLOB SOURCES "*.cc")
add_library(srsepc_sgw STATIC ${SOURCES})
install(TARGETS srsepc_sgw DESTINATION ${LIBRARY_DIR})

=== srsue/test/phy/CMakeLists.txt ===
#
# Copyright 2013-2017 Software Radio Systems Limited
#
# This file is part of srsLTE
#
# srsLTE is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# srsLTE is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# A copy of the GNU Affero General Public License can be found in
# the LICENSE file in the top-level directory of this distribution
# and at http://www.gnu.org/licenses/.
#

#add_executable(ue_itf_test_sib1 ue_itf_test_sib1.cc)
#target_link_libraries(ue_itf_test_sib1 srsue_phy srslte_common srslte_phy srslte_radio ${CMAKE_THREAD_LIBS_INIT} ${Boost_LIBRARIES})

#add_executable(ue_itf_test_prach ue_itf_test_prach.cc)
#target_link_libraries(ue_itf_test_prach srsue_phy srslte_common srslte_phy srslte_radio ${CMAKE_THREAD_LIBS_INIT} ${Boost_LIBRARIES})

=== lib/src/phy/channel/CMakeLists.txt ===
#
# Copyright 2013-2017 Software Radio Systems Limited
#
# This file is part of srsLTE
#
# srsLTE is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# srsLTE is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# A copy of the GNU Affero General Public License can be found in
# the LICENSE file in the top-level directory of this distribution
# and at http://www.gnu.org/licenses/.
#

file(GLOB SOURCES "*.c")
add_library(srslte_channel OBJECT ${SOURCES})

=== debian/changelog ===
srslte (18.06.1+ds.1-1build1) jammy; urgency=medium

  * No-change rebuild against libsoapysdr0.8

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 08 Nov 2021 19:12:59 +0000

srslte (18.06.1+ds.1-1) unstable; urgency=medium

  * Remove file without source from orig source
  * d/copyright: Remove duplicate entry
  * d/patches/0010-Fix-build-for-GCC-10.patch:
    - Fix FTBFS with GCC 10 (Closes: #966890)
  * d/rules: Disable tests for now

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sat, 23 Jan 2021 23:40:13 +0100

=== debian/control ===
Source: srslte
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Mobcom Maintainers <Debian-mobcom-maintainers@lists.alioth.debian.org>
Uploaders: Ruben Undheim <ruben.undheim@gmail.com>
Build-Depends: debhelper-compat (= 12),
               cmake,
               libfftw3-dev,
               libmbedtls-dev,
               libboost-program-options-dev,
               libconfig++-dev,
               libsctp-dev,
               libuhd-dev (>= 3.14),
               uhd-host,
               txt2man,
               libpcsclite-dev,
               libbladerf-dev (>= 0.2019.07),
               libsoapysdr-dev
Standards-Version: 4.5.0
Homepage: http://www.softwareradiosystems.com
Vcs-Git: https://salsa.debian.org/debian-mobcom-team/srslte.git
Vcs-Browser: https://salsa.debian.org/debian-mobcom-team/srslte

Package: srslte-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         srslte-core:any (= ${binary:Version})
Description: Static libraries and headers for srslte
 This software allows you to run a full end-to-end, open-source LTE system.
 It contains a UE, eNB and EPC implementation.
 .
 This package contains the development files - static libraries and headers

Package: srslte
Architecture: all
Depends: ${shlibs:Depends},
         ${misc:Depends},
         srsenb       (>= ${source:Version}), srsenb (<< ${source:Upstream-Version}.0~),
         srsue        (>= ${source:Version}), srsue  (<< ${source:Upstream-Version}.0~),
         srsepc       (>= ${source:Version}), srsepc (<< ${source:Upstream-Version}.0~)
Suggests: nextepc
Description: LTE software suite for software defined radios (metapackage)
 This software enables running a full end-to-end, open-source LTE system. It
 contains a UE, eNB and EPC implementation.
 .
 For running a full network, also an implementation of the Evolved Packet Core
 (EPC) is needed.

Package: srsenb
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         srslte-core (= ${binary:Version})
Suggests: nextepc
Breaks: srslte (<< 18.06.1-7)
Replaces: srslte (<< 18.06.1-7)
Description: Evolved Node B in LTE network for Software Defined Radios
 This software enables running a "base-station" for an LTE network.
 .
 For running a full network, also an implementation of the Evolved Packet Core
 (EPC) is needed. (such as nextepc)
 .
 It contains the evolved Node B (eNB) component of the network.

Package: srsue
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         srslte-core (= ${binary:Version})
Breaks: srslte (<< 18.06.1-7)
Replaces: srslte (<< 18.06.1-7)
Description: User Equipment implementation for LTE
 This software enables using a software defined radio as the user equipment
 connecting to an LTE network.
 .
 srsue provides a complete SDR LTE UE application featuring all layers from PHY
 to IP.
 .
 For running an LTE network, 'srsenb' should be used instead.

Package: srsepc
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         srslte-core (= ${binary:Version})
Recommends: srsenb
Breaks: srslte (<< 18.06.1-7)
Replaces: srslte (<< 18.06.1-7)
Description: Light-weight LTE core network implementation
 Together with 'srsenb', this software opens up the possibility to run an LTE
 network using a software defined radio.
 .
 It is a lightweight alternative to tools such as nextepc.

Package: srslte-core
Architecture: any
Multi-Arch: allowed
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: srslte (<< 18.06.1-7)
Replaces: srslte (<< 18.06.1-7)
Description: Common files for srsLTE
 This software enables running a full end-to-end, open-source LTE system. It
 contains a UE, eNB and EPC implementation.
 .
 For running a full network, also an implementation of the Evolved Packet Core
 (EPC) is needed.
 .
 This package contains the common files for srsenb, srsue and srsepc.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk


export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# To get cmake to pick up hardening flags when invoked directly:
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)
#


CHANGELOG_DATE ?= $(shell LC_ALL=C date -u -d @$(SOURCE_DATE_EPOCH) +"%d %B %Y")

multiarch = $(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)
arch = $(shell dpkg-architecture -qDEB_BUILD_ARCH)

%:
	dh $@

override_dh_auto_configure-indep:

override_dh_auto_configure-arch:
	dh_auto_configure -a -- -DRPATH=1 -DCUSTOM_RPATH=/usr/lib/srslte -DENABLE_SSE=0 -DENABLE_AVX=0 -DENABLE_AVX2=0 -DENABLE_FMA=0 -DENABLE_AVX512=0 -DENABLE_NEON=0 -DDISABLE_SIMD=1
	if [ "${arch}" = "amd64" ] || \
	   [ "${arch}" = "i386" ] ; then \
	  mkdir -p obj_avx && cd obj_avx && cmake -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=None -DCMAKE_INSTALL_SYSCONFDIR=/etc -DCMAKE_INSTALL_LOCALSTATEDIR=/var -DCMAKE_EXPORT_NO_PACKAGE_REGISTRY=ON -DCMAKE_FIND_PACKAGE_NO_PACKAGE_REGISTRY=ON -DCMAKE_INSTALL_RUNSTATEDIR=/run "-GUnix Makefiles" -DCMAKE_VERBOSE_MAKEFILE=ON -DCMAKE_INSTALL_LIBDIR=lib/$(multiarch) -DRPATH=1 -DCUSTOM_RPATH=/usr/lib/srslte/avx -DENABLE_AVX512=0 -DENABLE_FMA=0 -DENABLE_AVX2=0 -DDISABLE_SIMD=1 .. ; cd .. ; \
	  mkdir -p obj_avx2 && cd obj_avx2 && cmake -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=None -DCMAKE_INSTALL_SYSCONFDIR=/etc -DCMAKE_INSTALL_LOCALSTATEDIR=/var -DCMAKE_EXPORT_NO_PACKAGE_REGISTRY=ON -DCMAKE_FIND_PACKAGE_NO_PACKAGE_REGISTRY=ON -DCMAKE_INSTALL_RUNSTATEDIR=/run "-GUnix Makefiles" -DCMAKE_VERBOSE_MAKEFILE=ON -DCMAKE_INSTALL_LIBDIR=lib/$(multiarch) -DRPATH=1 -DCUSTOM_RPATH=/usr/lib/srslte/avx2 -DENABLE_AVX512=0 -DDISABLE_SIMD=1 .. ; cd .. ; \
	  mkdir -p obj_sse4 && cd obj_sse4 && cmake -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=None -DCMAKE_INSTALL_SYSCONFDIR=/etc -DCMAKE_INSTALL_LOCALSTATEDIR=/var -DCMAKE_EXPORT_NO_PACKAGE_REGISTRY=ON -DCMAKE_FIND_PACKAGE_NO_PACKAGE_REGISTRY=ON -DCMAKE_INSTALL_RUNSTATEDIR=/run "-GUnix Makefiles" -DCMAKE_VERBOSE_MAKEFILE=ON -DCMAKE_INSTALL_LIBDIR=lib/$(multiarch) -DRPATH=1 -DCUSTOM_RPATH=/usr/lib/srslte/sse4 -DENABLE_AVX512=0 -DENABLE_FMA=0 -DENABLE_AVX2=0 -DENABLE_AVX=0 -DDISABLE_SIMD=1 .. ; cd .. ; \
	fi
	# Build of NEON for ARM has been disabled since it FTBFS with the current version:
	#if [ "${arch}" = "armel" ] || \
	#   [ "${arch}" = "armhf" ] ; then \
	#  mkdir -p obj_neon && cd obj_neon && cmake -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=None -DCMAKE_INSTALL_SYSCONFDIR=/etc -DCMAKE_INSTALL_LOCALSTATEDIR=/var -DCMAKE_EXPORT_NO_PACKAGE_REGISTRY=ON -DCMAKE_FIND_PACKAGE_NO_PACKAGE_REGISTRY=ON -DCMAKE_INSTALL_RUNSTATEDIR=/run "-GUnix Makefiles" -DCMAKE_VERBOSE_MAKEFILE=ON -DCMAKE_INSTALL_LIBDIR=lib/$(multiarch) -DRPATH=1 -DCUSTOM_RPATH=/usr/lib/srslte/neon -DENABLE_AVX512=0 -DENABLE_FMA=0 -DENABLE_AVX2=0 -DDISABLE_SIMD=1 .. ; \
	#fi


override_dh_installman-indep:

override_dh_installman-arch:
	cd debian/man ; CHANGELOG_DATE="$(CHANGELOG_DATE)" ./genmanpages.sh
	dh_installman -a

override_dh_auto_clean:
	dh_auto_clean
	$(RM) debian/man/*.1
	$(RM) -r obj_avx
	$(RM) -r obj_avx2
	$(RM) -r obj_sse4
	$(RM) -r obj_neon
	$(RM) -r debian/tmp_avx
	$(RM) -r debian/tmp_avx2
	$(RM) -r debian/tmp_sse4
	$(RM) -r debian/tmp_neon


override_dh_auto_build-indep:

override_dh_auto_build-arch:
	dh_auto_build -a
	if [ "${arch}" = "amd64" ] || \
	   [ "${arch}" = "i386" ] ; then \
	  cd obj_avx && make ; cd .. ; \
	  cd obj_avx2 && make ; cd .. ; \
	  cd obj_sse4 && make ; cd .. ; \
	fi
	#if [ "${arch}" = "armel" ] || \
	#   [ "${arch}" = "armhf" ] ; then \
	#  cd obj_neon && make ; \
	#fi


override_dh_auto_install-indep:

override_dh_auto_install-arch:
	dh_auto_install -a
	if [ "${arch}" = "amd64" ] || \
	   [ "${arch}" = "i386" ] ; then \
	  cd obj_avx && mkdir -p ../debian/tmp_avx && make DESTDIR=../debian/tmp_avx install ; cd .. ; \
	  cd obj_avx2 && mkdir -p ../debian/tmp_avx2 && make DESTDIR=../debian/tmp_avx2 install ; cd .. ; \
	  cd obj_sse4 && mkdir -p ../debian/tmp_sse4 && make DESTDIR=../debian/tmp_sse4 install ; cd .. ; \
	fi
	#if [ "${arch}" = "armel" ] || \
	#   [ "${arch}" = "armhf" ] ; then \
	#  cd obj_neon && mkdir -p ../debian/tmp_neon && make DESTDIR=../debian/tmp_neon install ; \
	#fi

override_dh_install-arch:
	dh_install -a
	if [ "${arch}" = "amd64" ] || \
	   [ "${arch}" = "i386" ] ; then \
	  mkdir -p debian/srslte-core/usr/lib/srslte/avx ; \
	  mkdir -p debian/srslte-core/usr/lib/srslte/avx2 ; \
	  mkdir -p debian/srslte-core/usr/lib/srslte/sse4 ; \
	  mkdir -p debian/srsenb/usr/lib/srslte/bin ; \
	  mkdir -p debian/srsue/usr/lib/srslte/bin ; \
	  cp debian/tmp_avx/usr/lib/srslte/libsrslte_rf.so debian/srslte-core/usr/lib/srslte/avx/ ; \
	  cp debian/tmp_avx/usr/bin/srsenb debian/srsenb/usr/lib/srslte/bin/srsenb-avx ; \
	  cp debian/tmp_avx/usr/bin/srsue debian/srsue/usr/lib/srslte/bin/srsue-avx ; \
	  cp debian/tmp_avx2/usr/lib/srslte/libsrslte_rf.so debian/srslte-core/usr/lib/srslte/avx2/ ; \
	  cp debian/tmp_avx2/usr/bin/srsenb debian/srsenb/usr/lib/srslte/bin/srsenb-avx2 ; \
	  cp debian/tmp_avx2/usr/bin/srsue debian/srsue/usr/lib/srslte/bin/srsue-avx2 ; \
	  cp debian/tmp_sse4/usr/lib/srslte/libsrslte_rf.so debian/srslte-core/usr/lib/srslte/sse4/ ; \
	  cp debian/tmp_sse4/usr/bin/srsenb debian/srsenb/usr/lib/srslte/bin/srsenb-sse4 ; \
	  cp debian/tmp_sse4/usr/bin/srsue debian/srsue/usr/lib/srslte/bin/srsue-sse4 ; \
	  mv debian/srsue/usr/bin/srsue debian/srsue/usr/lib/srslte/bin/srsue-generic ; \
	  mv debian/srsenb/usr/bin/srsenb debian/srsenb/usr/lib/srslte/bin/srsenb-generic ; \
	  cp debian/script/srsenb debian/srsenb/usr/bin/srsenb ; \
	  cp debian/script/srsue debian/srsue/usr/bin/srsue ; \
	fi
	#if [ "${arch}" = "armel" ] || \
	#   [ "${arch}" = "armhf" ] ; then \
	#  mkdir -p debian/srslte-core/usr/lib/srslte/neon ; \
	#  mkdir -p debian/srslte-core/usr/lib/srslte/bin ; \
	#  cp debian/tmp_avx/usr/lib/srslte/libsrslte_rf.so debian/srslte-core/usr/lib/srslte/neon/ ; \
	#  cp debian/tmp_avx/usr/bin/srsenb debian/srsenb/usr/lib/srslte/bin/srsenb-neon ; \
	#  cp debian/tmp_avx/usr/bin/srsue debian/srsue/usr/lib/srslte/bin/srsue-neon ; \
	#  mv debian/srslte/usr/bin/srsue debian/srsue/usr/lib/srslte/bin/srsue-generic ; \
	#  mv debian/srslte/usr/bin/srsenb debian/srsenb/usr/lib/srslte/bin/srsenb-generic ; \
	#  cp debian/script/srsenb debian/srsenb/usr/bin/srsenb ; \
	#  cp debian/script/srsue debian/srsue/usr/bin/srsue ; \
	#fi


override_dh_auto_test-indep:

# Tests pass when building without SIMD extensions on a few architectures, but not with:
# - AVX extensions (without AVX2)
# - SSE4.2 extensions (without AVX2 and AVX)
override_dh_auto_test-arch:
	#if [ "${arch}" = "amd64" ] || \
	#   [ "${arch}" = "arm64" ] || \
	#   [ "${arch}" = "alpha" ] || \
	#   [ "${arch}" = "ppc64el" ] ; then \
	#  dh_auto_test -a ; \
	#else \
	#  echo "Skipping tests on this architecture" ; \
	#fi
	##if [ "${arch}" = "amd64" ] || \
	##   [ "${arch}" = "i386" ] ; then \
	##  cd obj_avx  && make test ; cd .. ; \
	##  cd obj_avx2 && make test ; cd .. ; \
	##  cd obj_sse4 && make test ; cd .. ; \
	##fi

override_dh_installsystemd:
	dh_installsystemd --no-enable --no-start
